/* 
 * IocHub Demo for Linux       
 *
 * Copyright (C) 2004-2023 Nanjing Qinheng Microelectronics Co., Ltd.
 * Web:      http://wch.cn
 * Author:   WCH <tech@wch.cn>
 * Version:  V1.1
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 */
 
#include "mainwindow.h"

#include <QApplication>
#include <QDebug>
#include <QTextCodec>

#include "iochub.h"
#include <sys/timeb.h>

void prettyHex(QByteArray inArr)
{
    QByteArray retArr;
    for (int i = 0 , iMax = inArr.size(); i < iMax; i++) {
        retArr.append(inArr.mid(i, 1).toHex() + " ");
    }
    retArr.chop(1);

    qDebug()<< "tcp call back data frame is " << retArr;
}

int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    QApplication a(argc, argv);

    MainWindow w;
    char version[128];
    memset(version, 0, 128);
    int versionLen = 0;
    IoCHub_GetSDKVersion(version, &versionLen);
    qDebug() << "SDK Version:" << QByteArray(version);
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("utf-8"));
    w.show();
    return a.exec();
}
