/********************************** (C) COPYRIGHT *******************************
 * File Name          : app_net.c
 * Author             : WCH
 * Version            : V1.0
 * Date               :
 * Description        : netʾ
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/
#include "string.h"
#if defined(CH32V20X) || defined(CH32V30X)	
#include "debug.h"
#endif
#include "app_net.h"
#include "wchiochub.h"
/*
 *@Note
 TcpClienṭʾTcp clientӷٻش
 */
#define KEEPLIVE_ENABLE                           /*ʹkeeplive*/
#define TCP_SINGLE_CLIENT                         /*һͻˣͻʱע WCHNET_NUM_TCP ֵ*/

u8 MACAddr[6]; /*Macַ*/
u8 IPAddr[4] = { 192, 168, 1, 10 }; /*IPַ*/
u8 GWIPAddr[4] = { 192, 168, 1, 1 }; /**/
u8 IPMask[4] = { 255, 255, 255, 0 }; /**/
u8 DESIP[4] = { 192, 168, 1, 100 }; /*ĿIPַ*/

u8 dhcpflag = 0;
u8 socket[WCHNET_MAX_SOCKET_NUM];
u8 SocketRecvBuf[WCHNET_MAX_SOCKET_NUM][RECE_BUF_LEN]; /*socket*/
u8 MyBuf[RECE_BUF_LEN];


void NET_Send (uint8_t socketid, uint8_t *buf, uint32_t len)
{
    uint32_t sendlen = len;
    /* bufеݷ */
    WCHNET_SocketSend (socketid, buf, &sendlen);

}

void UDP_Send (uint8_t socketid, uint8_t *buf, uint32_t slen, uint8_t *dstIP, uint16_t port)
{
    uint32_t sendlen = slen;
    uint16_t dstport = port;
    WCHNET_SocketUdpSendTo (socketid, buf, &sendlen, dstIP, dstport);
}

/*********************************************************************
 * @fn      mStopIfError
 *
 * @brief   check if error.
 *
 * @return  none
 */
void mStopIfError (u8 iError)
{
    if (iError == WCHNET_ERR_SUCCESS)
        return; /*ɹ */

    printf ("Error: %02X\r\n", (u16) iError); /*ʾ */
}

/*******************************************************************************
 * Function Name  : appCallBack
 * Description    : UDPջص
 * Input          :
 * Output         : None
 * Return         : None
 ********************************************************************************/
void udpCallBack (struct _SCOK_INF *socinf, uint32_t ipaddr, uint16_t port, uint8_t *buf, uint32_t len)
{
    memcpy (udpAddr.addr, &ipaddr, 4);
    udpAddr.port = port;
    WCHIOCHUB_NetDataToUsrData(buf, len);
}

/*********************************************************************
 * @fn      WCHNET_CreatTcpSocket
 *
 * @brief   Creat Tcp Socket
 *
 * @return  none
 */
void WCHNET_CreatTcpSocket (uint32_t srcport, uint32_t desport, uint8_t *DESIP, uint8_t *SocketId)
{
    uint8_t i;
    SOCK_INF TmpSocketInf; /* ʱsocket */
    /* һͻ*/
    memset ((void *) &TmpSocketInf, 0, sizeof(
                SOCK_INF)); /* ڲὫ˱ƣýʱȫ */
    memcpy ((void *) TmpSocketInf.IPAddr, DESIP, 4); /* ĿIPַ */
    TmpSocketInf.DesPort = desport; /* ĿĶ˿ */
    TmpSocketInf.SourPort = srcport; /* Դ˿ */
    TmpSocketInf.ProtoType = PROTO_TYPE_TCP; /* socekt */
    TmpSocketInf.RecvBufLen = RECE_BUF_LEN; /* ýջĽճ */
    i = WCHNET_SocketCreat (SocketId,
                            &TmpSocketInf); /* socketصsocketSocketId 㿪ʼ*/
    mStopIfError (i); /*   */
    i = WCHNET_SocketConnect (*SocketId); /* TCP  */
    mStopIfError (i); /*   */

}

/*********************************************************************
 * @fn      WCHNET_CreatUdpSocket
 *
 * @brief   Creat Udp Socket
 *
 * @return  none
 */
void WCHNET_CreatUdpSocket (uint32_t srcport, uint8_t *SocketId)
{
    u8 i;
    SOCK_INF TmpSocketInf; /* ʱsocket */
    memset ((void *) &TmpSocketInf, 0, sizeof(SOCK_INF)); /* ڲὫ˱ƣýʱȫ */
    TmpSocketInf.SourPort = srcport; /* Դ˿ */
    TmpSocketInf.ProtoType = PROTO_TYPE_UDP; /* socekt */
    TmpSocketInf.RecvBufLen = RECE_BUF_LEN; /* ýջĽճ */
    TmpSocketInf.AppCallBack = udpCallBack;
    i = WCHNET_SocketCreat (SocketId, &TmpSocketInf); /* socketصsocketSocketId */\
    WCHNET_ModifyRecvBuf(*SocketId, (u32) SocketRecvBuf[*SocketId], RECE_BUF_LEN);
    mStopIfError (i); /*  */

}

/*********************************************************************
 * @fn      WCHNET_HandleSockInt
 *
 * @brief   Socket Interrupt Handle
 *
 * @return  none
 */
void WCHNET_HandleSockInt (u8 socketid, u8 initstat)
{
    uint32_t len;
    if (initstat & SINT_STAT_RECV) /* socketж*/
    {
        len = WCHNET_SocketRecvLen (socketid, NULL); /* ȡsocketݳ  */
        WCHNET_SocketRecv (socketid, MyBuf, &len); /* ջݶMyBuf*/
        WCHIOCHUB_NetDataToUsrData( MyBuf, len);
    }

    if (initstat & SINT_STAT_CONNECT) /* socketӳɹж*/
    {
        #ifdef KEEPLIVE_ENABLE
        WCHNET_SocketSetKeepLive (socketid, ENABLE);
        #endif
        printf ("TCP CONNECT SUCCESS, Socketid: %d    TCP_SOUR_Port:%u\r\n",
                socketid, iochubScrPort);
        WCHNET_ModifyRecvBuf(socketid, (u32) SocketRecvBuf[socketid], RECE_BUF_LEN);
        if (iochubScrPort == SocketInf[socketid].SourPort)
        {
        	SocketIdForSer = socketid;
            socketIsSucc |= 0x01;
        }

        printf ("socketIsSucc: %d\r\n", socketIsSucc);
    }

    if (initstat & SINT_STAT_DISCONNECT) /* socketӶϿж*/
    {
        printf ("TCP Disconnect\r\n");
    }

    if (initstat & SINT_STAT_TIM_OUT) /* socketӳʱж*/
    {
        printf ("TCP Timeout\r\n"); /* ʱ200ms*/
    }
}

/*********************************************************************
 * @fn      WCHNET_HandleGlobalInt
 *
 * @brief   Global Interrupt Handle
 *
 * @return  none
 */
void WCHNET_HandleGlobalInt (void)
{
    u8 initstat;
    u16 i;
    u8 socketinit;

    initstat = WCHNET_GetGlobalInt (); /* ȡȫжϱ־*/

    if (initstat & GINT_STAT_UNREACH) /* ɴж */
    {
        printf ("GINT_STAT_UNREACH\r\n");
    }

    if (initstat & GINT_STAT_IP_CONFLI) /* IPͻж */
    {
        printf ("GINT_STAT_IP_CONFLI\r\n");
    }

    if (initstat & GINT_STAT_PHY_CHANGE) /* PHY״̬仯ж */
    {
        i = WCHNET_GetPHYStatus (); /* ȡPHY״̬*/

        if (i & PHY_Linked_Status)
            printf ("PHY Link Success\r\n");
    }

    if (initstat & GINT_STAT_SOCKET)
    {
        for (i = 0; i < WCHNET_MAX_SOCKET_NUM; i++)
        {
            socketinit = WCHNET_GetSocketInt (i);

            if (socketinit)
                WCHNET_HandleSockInt (i, socketinit);
        }
    }
}

/*******************************************************************************
 * Function Name  : WCHNET_DHCPCallBack
 * Description    : DHCPص
 * Input          : None
 * Output         : None
 * Return         : ִ״̬
 *******************************************************************************/
uint8_t WCHNET_DHCPCallBack (uint8_t status, void *arg)
{
    uint8_t *p;
    dhcpflag = 1;
    if (!status)
    {
        p = arg;
        printf ("DHCP Success\r\n");
        memcpy (IPAddr, p, 4);
        memcpy (GWIPAddr, &p[4], 4);
        memcpy (IPMask, &p[8], 4);
        printf ("IPAddr   = %d.%d.%d.%d \r\n", (u16) IPAddr[0], (u16) IPAddr[1],
                (u16) IPAddr[2], (u16) IPAddr[3]);
        printf ("GWIPAddr = %d.%d.%d.%d \r\n", (u16) GWIPAddr[0],
                (u16) GWIPAddr[1], (u16) GWIPAddr[2], (u16) GWIPAddr[3]);
        printf ("IPAddr   = %d.%d.%d.%d \r\n", (u16) IPMask[0], (u16) IPMask[1],
                (u16) IPMask[2], (u16) IPMask[3]);
        printf ("DNS1     = %d.%d.%d.%d \r\n", p[12], p[13], p[14], p[15]);
        printf ("DNS2     = %d.%d.%d.%d \r\n", p[16], p[17], p[18], p[19]);
        WCHNET_DHCPStop ();

        memcpy (localIP, IPAddr, 4);
        return 0;
    }
    else
    {
        printf ("DHCP Fail %02x \r\n", status);
        printf ("IPAddr   = %d.%d.%d.%d \r\n", (u16) IPAddr[0], (u16) IPAddr[1],
                (u16) IPAddr[2], (u16) IPAddr[3]);
        printf ("GWIPAddr = %d.%d.%d.%d \r\n", (u16) GWIPAddr[0],
                (u16) GWIPAddr[1], (u16) GWIPAddr[2], (u16) GWIPAddr[3]);
        printf ("IPAddr   = %d.%d.%d.%d \r\n", (u16) IPMask[0], (u16) IPMask[1],
                (u16) IPMask[2], (u16) IPMask[3]);
        WCHNET_DHCPStop ();
        memcpy (localIP, IPAddr, 4);

        return 1;
    }
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program
 *
 * @return  none
 */
void NET_Init (void)
{
    u8 i;
    PRINT("net version:%x\n", WCHNET_GetVer ());

    if ( WCHNET_LIB_VER != WCHNET_GetVer ())
    {
    	PRINT("version error.\n");
    }
    WCHNET_GetMacAddr (MACAddr); /*ȡоƬMacַ*/
    PRINT("mac addr:");
    for ( i = 0; i < 6; i++)
    	PRINT("%02X ", MACAddr[i]);
    PRINT("\n");

    i = ETH_LibInit (IPAddr, GWIPAddr, IPMask, MACAddr); /*̫ʼ*/
    mStopIfError (i);

    #ifdef KEEPLIVE_ENABLE
    {
        /*keeplive*/
        struct _KEEP_CFG cfg;
        cfg.KLIdle = 20000;
        cfg.KLIntvl = 15000;
        cfg.KLCount = 9;
        WCHNET_ConfigKeepLive (&cfg);
    }
    #endif
    memset(socket, 0xff, WCHNET_MAX_SOCKET_NUM);
    WCHNET_DHCPStart (WCHNET_DHCPCallBack);

    if (i == WCHNET_ERR_SUCCESS)
    	PRINT("WCHNET_LibInit Success\r\n");

}
