/********************************** (C) COPYRIGHT *******************************
 * File Name          : ch579_it.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 
 * Description 		  : 
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/
#include "ch579_it.h"
#include <wchnet.h>
#include "eth_driver.h"
#include "app_iochub.h"

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void)
{
    printf("HardFault_Handler\r\n");
    while (1);
}

/*********************************************************************
 * @fn      ETH_IRQHandler
 *
 * @brief   This function handles ETH exception.
 *
 * @return  none
 */
void ETH_IRQHandler(void)
{
    WCHNET_ETHIsr();
}

/*******************************************************************************
* Function Name  : TMR0_IRQHandler
* Description    : This function handles TMR0 exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void TMR0_IRQHandler( void ) 					                             	
{
	static uint8_t counter = 0;
	if(counter>=10)
	{
		counter = 0;
		WCHNET_TimeIsr(WCHNETTIMERPERIOD);
	}
	counter++;
	WCHIOCHUB_TimeIsr();                              
	R8_TMR0_INT_FLAG |= 0xff;					                      
}
