/********************************** (C) COPYRIGHT *******************************
 * File Name          : wchiochub.h
 * Author             : WCH
 * Version            : V1.0
 * Date               :
 * Description        : wchiochub接口定义
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/
#ifndef __WCHIOCHUB_H_
#define __WCHIOCHUB_H_

#include "stdint.h"


#define MAX_CONNECT_NUM							(7UL)    	/*最大支持连接数为7*/
#define IOC_DATA_BUF_LEN						(512UL)
#define CONNECT_NUM								(2UL)    	/*用户自行配置的会话数量*/
#define	IOC_SESSION_HANDLE_TABLE_SIZE			(CONNECT_NUM*32UL)
#define IOC_FRAME_SIZE							(IOC_DATA_BUF_LEN+20UL)
#define IOC_FRAME_NUM							(2*CONNECT_NUM+2)
#define IOC_RECV_BUF_SIZE						(IOC_FRAME_SIZE*4)

#define IOC_MEMP_SIZE							(IOC_SESSION_HANDLE_TABLE_SIZE+IOC_RECV_BUF_SIZE+(IOC_FRAME_SIZE*IOC_FRAME_NUM))

#define LAN_SCAN_FUNC_ENABLE					0
#define IOC_LAN_DEVICE_NUM						(3UL)
/****************ErrorCode*******************/
#define IOCHUB_SUCCESS                          0UL         /*操作成功*/
#define IOCHUB_REGISTERING                      100UL       /*正在注册连接*/
#define IOCHUB_REGISTERED                       101UL       /*设备已注册*/
#define IOCHUB_REGISTER_FAIL                    102UL       /*注册失败*/
#define IOCHUB_LOGIN_FAIL                       103UL       /*登录失败*/
#define IOCHUB_CNT_COMM_SER_FAIL                104UL       /*连接通信服务失败*/
#define IOCHUB_SER_EXCEPTIONS                   105UL       /*服务异常(需要重试)*/
#define IOCHUB_CNT_COMM_SER_TIMEOUT             106UL       /*连接通信服务超时*/
#define IOCHUB_GET_DEVICEID_FAIL                107UL       /*获取本机标识失败*/
#define IOCHUB_UPLOAD_NATTYPE_FAIL              108UL       /*上报NAT类型失败*/
#define IOCHUB_INPUT_IP_FORMAT_ERR              109UL       /*输入IP及端口格式不正确*/
#define IOCHUB_ACCESS_MODE_SET_FAIL             110UL       /*设备验证模式设置失败(服务已启动)*/

#define IOCHUB_DEVICE_UNREGISTER                200UL       /*设备未注册*/
#define IOCHUB_LAN_SCANNING                     201UL       /*正在进行局域网发现*/
#define IOCHUB_BROADCAST_PORT_USED              202UL       /*广播端口被占用(广播端口默认：10000)*/
#define IOCHUB_UNINIT                           203UL       /*未初始化IoCHub库*/
#define IOCHUB_LAN_SCANNING_DISABLE             204UL       /*本机局域网发现不可用*/

#define IOCHUB_SESSION_EXIT                     300UL       /*会话已存在*/
#define IOCHUB_LOAD_FULL                        301UL       /*会话连接数已达上限*/
#define IOCHUB_SESSION_OPENING                  302UL       /*正在打开会话*/
#define IOCHUB_DEVICE_OFFLINE                   303UL       /*当前设备未登录连接*/
#define IOCHUB_DST_DEVICE_OFFLINE               304UL       /*目标会话设备不在线*/
#define IOCHUB_DST_DEVICE_LOAD_FULL             305UL       /*目标设备会话连接数已达上限*/
#define IOCHUB_SESSION_OPEN_FAIL                306UL       /*打开会话失败*/
#define IOCHUB_SESSION_OPEN_TIMEOUT             307UL       /*打开会话超时*/
#define IOCHUB_REG_BROADCAST_FAIL               308UL       /*注册广播失败*/
#define IOCHUB_REGISTERED_BROADCAST             309UL       /*已经注册广播*/
#define IOCHUB_DSTID_IS_LOCALID                 310UL       /*目标会话设备ID为本机ID*/
#define IOCHUB_SESSION_CLOSE_FAIL               311UL       /*关闭会话失败*/
#define IOCHUB_LAWLESS_DEVID                    312UL       /*非法设备ID*/
#define IOCHUB_DSTDEV_BUSY                      313UL       /*目标设备正忙(需要重试)*/
#define IOCHUB_SESSION_CAPTCHA_FORMAT_ERR       314UL       /*会话验证码格式不正确*/
#define IOCHUB_SESSION_CAPTCHA_NOT_MATCH        315UL       /*会话验证码不匹配*/
#define IOCHUB_REJECT_SESSION_CONNECT           316UL       /*拒绝会话连接*/

#define IOCHUB_SESSION_NOT_EXIT                 400UL       /*会话不存在*/
#define IOCHUB_TXBUF_OVERFLOW                   401UL       /*发送缓冲区溢出*/
#define IOCHUB_RXBUF_OVERFLOW                   402UL       /*接收缓冲区溢出*/
 
#define IOCHUB_SOCKET_CREATE_FAIL               500UL       /*Socket创建失败*/
#define IOCHUB_SOCKET_CONNECT_TIMEOUT           501UL       /*Socket连接超时*/
#define IOCHUB_SOCKET_CONNECT_FAIL              502UL       /*Socket连接失败*/
#define IOCHUB_SOCKET_READ_ABNORMAL             503UL       /*Socket读异常*/
#define IOCHUB_SOCKET_WRITE_ABNORMAL            504UL       /*Socket写异常*/
#define IOCHUB_SOCKET_CHANNEL_ABNORMAL          505UL       /*Socket通道异常*/
#define IOCHUB_REMOTE_ADDR_UNREACHABLE          506UL       /*远程地址不可达*/
#define IOCHUB_DEVICE_DISC_ABNORMAL             600UL       /*设备异常断开*/
#define IOCHUB_UDPUPDATE_REMOTEADDR_ABNORMAL    601UL       /*UDP更新远程连接地址异常*/
#define IOCHUB_REQUEST_PARAM_INVALID            700UL       /*请求参数无效*/
#define IOCHUB_DEVICE_CONNTED_FORBID_CFGPARAM   701UL       /*设备已连接,不能进行参数配置*/
#define IOCHUB_HANDLE_INVALID                   702UL       /*无效句柄*/
#define IOCHUB_PARAM_INVALID                    703UL       /*配置参数无效*/
#define IOCHUB_MSG_ARRAY_FULL                   704UL       /*消息队列已满*/
#define IOCHUB_LIB_INIT_FAIL                    705UL       /*初始化IoCHub库失败*/


typedef uint8_t IoCHubHANDLE;

typedef struct
{
    uint8_t addr[4];
    uint16_t port;
} UDP_ADDR_S;

typedef struct
{
	uint8_t dstDevID[8];
	uint8_t dstDevIP[4];
	uint16_t dstDevPort;
	uint16_t msgSeq;
	uint16_t msgSeqFlag;
	uint16_t localMsgSeq;
	uint8_t transferType;
	uint8_t flag;
	uint8_t taskID;
	uint8_t TransTimeoutCount;
}IOCHUB_SESSION_HANDLE;

typedef struct
{
	uint8_t DevID[8]; //设备标识
	uint8_t LanIP[4]; //内网IP
} IOCHUB_LAN_DEVICE_INFO;


extern uint8_t SocketIdForSer;
extern uint8_t socketIsSucc;
extern uint16_t iochubScrPort;
extern uint8_t localIP[4];//本地IP
extern UDP_ADDR_S udpAddr;
extern IoCHubHANDLE sessionHdl;
//extern void WCHIOCHUB_SwitchTestOffline(void);
//extern void WCHIOCHUB_SwitchTestOppositeSide(void);

typedef void(*TcpSendP)(uint8_t, uint8_t*, uint32_t);
typedef void(*UdpSendP)(uint8_t, uint8_t*, uint32_t, uint8_t*, uint16_t);
typedef void(*TcpConnectP)(uint32_t, uint32_t, uint8_t*, uint8_t*);
typedef void(*UdpConnectP)(uint32_t, uint8_t*);
typedef uint8_t(*ConnectionCloseP )(uint8_t, uint8_t);
typedef void (*IocHubDataRecvCallBackP)(uint8_t,uint8_t *, uint16_t);
typedef void (*IocHubRegCallBackP)(uint16_t);
typedef void (*IocHubSessionStateCallBackP)(uint8_t,uint16_t);
#if LAN_SCAN_FUNC_ENABLE
typedef void (*LanScanDeviceCallBackP)(uint8_t,IOCHUB_LAN_DEVICE_INFO*);//局域网扫描回调函数
#endif
typedef uint32_t (*RTC_GetCycle)(void);

typedef enum CHIP_TYPE
{
	CH579x = 1,
	CH32V307,
	CH32V208
}CHIP_TYPE;

#ifdef CH32V30X
#define CHIPTYPE 	CH32V307
#endif
#ifdef CH32V20X
#define CHIPTYPE 	CH32V208
#endif
#ifdef CH579
#define CHIPTYPE 	CH579x
#endif
/* 参数配置结构体 */
typedef struct TAG_IOCHUB_CONFIG
{
    uint16_t sendDataSize;
    uint16_t ringBufLen;
	uint8_t* iochubBuf;

    RTC_GetCycle pIoChubGetTimeIsr;
    TcpSendP pTcpSendF;
    UdpSendP pUdpSendF;
    TcpConnectP pTcpConnectF;
    UdpConnectP pUdpConnectF;
    ConnectionCloseP pConnectCloseF;
    IocHubDataRecvCallBackP pDataRecvCB;
	IocHubSessionStateCallBackP pSessionStateCB;
	CHIP_TYPE chipType;
	uint8_t maxConnNum;
	uint8_t rfu[3];
} IOCHUB_CONFIG;

/*******************************************************************************
 * @fn          iochub_hex2Ascii
 *
 * @brief       hex转Ascii
 *
 * input parameters
 *
 * @param       *input 待转换的hex码
 *
 * @param       inputLen 输入长度
 *
 * output parameters
 *
 * @param       *output 转换输出
 *
 * @return      None
 */
void iochub_hex2Ascii(uint8_t *input, uint8_t inputLen, uint8_t *output);

/*******************************************************************************
 * @fn          iochub_ascii2Hex
 *
 * @brief       Ascii转hex
 *
 * input parameters
 *
 * @param       *input 待转换的hex码
 *
 * @param       inputLen 输入长度
 *
 * output parameters
 *
 * @param       *output 转换输出
 *
 * @return      None
 */
void iochub_ascii2Hex(uint8_t *input, uint8_t inputLen, uint8_t *output);

/*******************************************************************************
 * @fn          WCHIOCHUB_Init
 *
 * @brief       IocHub初始化
 *
 * input parameters
 *
 * @param       * Cfg 配置参数
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      注册指令执行成功状态
 */
void WCHIOCHUB_Init(IOCHUB_CONFIG* pCfg);

/*******************************************************************************
 * @fn          WCHIOCHUB_DeInit
 *
 * @brief       IocHub清理资源
 *
 * input parameters
 *
 * @param       * Cfg 配置参数结构体
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      注册指令执行成功状态 0-操作成功；
 *									 错误码-清理资源失败
 */
uint16_t WCHIOCHUB_DeInit(void);

/*******************************************************************************
 * @fn          WCHIOCHUB_GetCurrentCfg
 *
 * @brief       获取iochub当前参数配置
 *
 * input parameters
 *
 * @param       * Cfg 配置参数
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      注册指令执行成功状态
 */
void WCHIOCHUB_GetCurrentCfg(IOCHUB_CONFIG* pCfg);

/*******************************************************************************
 * @fn          WCHIOCHUB_start
 *
 * @brief       启动IoCHub服务
 *
 * input parameters
 *
 * @param serAddr 
 * @param serPort 
 * @param localPort 
 * @param deviceID 
 * @param deviceSecret
 * @param deviceLockFlag(设备锁)： 0x00:不锁定，0x01：锁定，默认 0x00
 * @param commMode(通信模式)：1：自动，2：手动，默认：1
 * @param pRegCB        连接鉴权阶段的状态回调函数
 *
 * output parameters
 *
 * @param       None
 *
 * @return uint16_t   0–启动服务成功
 *          	      错误码–启动失败
 */
uint16_t WCHIOCHUB_Start(uint8_t *serAddr, uint16_t serPort, uint16_t localPort,
                         uint8_t *deviceID, uint8_t *deviceSecret, uint8_t deviceLockFlag,
						 uint8_t commMode,IocHubRegCallBackP pRegCB);

/*******************************************************************************
 * @fn          WCHIOCHUB_Stop
 *
 * @brief       停止IoCHub服务
 *
 * input parameters
 *
 * @param       None
 *
 * output parameters
 *
 * @param       None
 *
 * @return      0		-停止服务成功
 *				错误码	-停止服务失败
 *
 */
uint16_t WCHIOCHUB_Stop(void);

/*******************************************************************************
 * @fn          WCHIOCHUB_DataRecv
 *
 * @brief      向IOCHUB传递从NET协议栈获取到的数据
 *
 * input parameters
 *
 * @param       len 待写长度
 *
 * @param       *wData 待写数据
 *
 * output parameters
 *
 * @param       None
 *
 * @return      执行完成状态
 */
uint16_t WCHIOCHUB_NetDataToUsrData(uint8_t *recvDataBuf, uint32_t recvDataSize);

/*******************************************************************************
 * @fn          WCHIOCHUB_DataSend
 *
 * @brief       客户端数据传输
 *
 * input parameters
 *
 * @param  uint8_t* sendDataBuf
 *
 * @param  uint16_t dataLen
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      执行完成状态
 */
uint16_t WCHIOCHUB_DataSend(IoCHubHANDLE  pDev,uint8_t*  sendDataBuf, uint16_t sendDataSize);

/*******************************************************************************
 * @fn          WCHIOCHUB_GetSDKVer
 *
 * @brief      获取库当前版本
 *
 * input parameters
 *
 * @param       None
 *
 * output parameters
 *
 * @param       verBuf[4] 版本号
 *
 * @return      None
 *
 */
void WCHIOCHUB_GetSDKVer(uint8_t verBuf[4]);

/*******************************************************************************
 * @fn          WCHIOCHUB_GetLocalID
 *
 * @brief      获取本设备唯一标识devID
 *
 * input parameters
 *
 * @param       None
 *
 * output parameters
 *
 * @param       devcID[8] 设备id
 *
 * @return      None
 *
 */
void WCHIOCHUB_GetLocalID(uint8_t devcID[8]);

/*******************************************************************************
 * @fn          WCHIOCHUB_GetNATType
 *
 * @brief      获取当前网络类型
 *
 * input parameters
 *
 * @param       None
 *
 * output parameters
 *
 * @param       None
 *
 * @return      NATType 网络类型
 *
 */
uint8_t WCHIOCHUB_GetNATType(void);


/*******************************************************************************
 * @fn          WCHIOCHUB_GetTransferType
 *
 * @brief      获取指定会话的数据传输方式
 *
 * input parameters
 *
 * @param       pDev 指定的会话Handle
 *
 * output parameters
 *
 * @param       None
 *
 * @return      dataTransType 数据传输方式
 *				0:服务器转发;
 *				1:点对点直连;
 *				0xff会话无效;
 *
 */
uint8_t WCHIOCHUB_GetTransferType(IoCHubHANDLE  pDev);


/*******************************************************************************
 * @fn          IoCHub_SetAccessMode
 *
 * @brief       设置访问模式模式，用于会话连接访问配置。
 *
 * input parameters
 *
 * @param       modeType	访问模式(1字节,默认0)
 * 							0:公开访问，只需要DevID即可建立会话连接;
 * 							1：受限访问，需要DevID及会话密钥建立会话连接;
 * 							2:私有,不接受建立会话连接请求;
 *
 * @param       sessionKey[8]	会话密钥(默认全0)
 *
 * output parameters
 *
 * @param       None
 *
 * @return      None
 *
 */
void WCHIOCHUB_SetAccessMode(uint8_t modeType, uint8_t sessionKey[8]);


/*******************************************************************************
 * @fn          IoCHub_GetAccessMode
 *
 * @brief       获取当前访问模式。
 *
 * input parameters
 *
 * @param       None
 *
 * output parameters
 *
 * @param       *modeType	访问模式,1字节
 *
 * @param       *sessionKey	会话密钥
 *
 * @return      None
 *
 */
void WCHIOCHUB_GetAccessMode(uint8_t* modeType, uint8_t sessionKey[8]);

/*******************************************************************************
 * @fn          WCHIOCHUB_OpenSession
 *
 * @brief       客户端 A 向服务器发起与另一个 客户端 B的连接请求
 *				此处服务器判断 NAT是否同一个内网,交换返回客户端的远程、本地 IP
 *				及端口，客户端获取到数据之后立刻开始打洞处理。
 *
 * input parameters
 *
 * @param       dstDevID[8] 目标设备ID
 *
 * @param       sessionKey[8] 目标验证码，默认全0
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      0-发起会话连接成功。
 *				错误码-发起会话连接失败。
 */
uint16_t WCHIOCHUB_OpenSession(IoCHubHANDLE* pDev, uint8_t dstDevcID[8], uint8_t sessionKey[8]);

/*******************************************************************************
 * @fn          WCHIOCHUB_CloseSession
 *
 * @brief       关闭会话
 *
 * input parameters
 *
 * @param       sessionHdl 会话handle
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      None.
 */
uint16_t WCHIOCHUB_CloseSession(uint8_t sessionHdl);

#if LAN_SCAN_FUNC_ENABLE
/*******************************************************************************
 * @fn          WCHIOCHUB_SetLanScan
 *
 * @brief       配置局域网扫描功能
 *
 * input parameters
 *
 * @param       pDevScanCB 扫描结果回调函数
 *
 * @param       *lanDeviceList 扫描设备列表
 *
 * @param       lanDeviceListMaxNum 最大扫描设备数量
 *
 * @param       enable  使能扫描功能
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      None.
 */
 uint16_t WCHIOCHUB_SetLanScan(LanScanDeviceCallBackP pDevScanCB,
 							  IOCHUB_LAN_DEVICE_INFO *lanDeviceList,
 							  uint8_t lanDeviceListMaxNum,
 							  uint8_t enable);

/*******************************************************************************
 * @fn          WCHIOCHUB_LanScan
 *
 * @brief       局域网设备扫描
 *
 * input parameters
 *
 * @param       scanTime 扫描时间（单位：s）
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      None.
 */
 void WCHIOCHUB_LanScan(uint8_t scanTime);
#endif

/* 库主任务函数，需要在主while中一直不断调用 */
void WCHIOCHUB_Process( void );

#endif
