//*******************************************
//**  Copyright  (C)  WCH  2004-2023       **
//**  Web:  http://wch.cn                  **
//*******************************************
//**  iochub libray for iOS/macOS          **
//*******************************************
//
// iocHub接口库 V1.1
// 南京沁恒微电子
// 运行环境: iOS/macOS
//

import UIKit

class ConfigParamsView: UIView, UITextFieldDelegate {
    
    @IBOutlet weak var centerLayoutConstraint: NSLayoutConstraint!
    
    @IBOutlet weak var receiveBufferSizeTextFiled: UITextField!
    
    @IBOutlet weak var sendBufferSizeTextField: UITextField!
    
    @IBOutlet weak var socketTimeOutTextField: UITextField!
    
    @IBOutlet weak var maxConnectTextField: UITextField!
    
    @IBOutlet weak var packageSizeTextField: UITextField!
    
    @IBOutlet weak var windowSizeTextField: UITextField!
    
    @IBOutlet weak var windowTimeOutTextField: UITextField!
    
    @IBOutlet weak var compressButton: UIButton!
    
    @IBOutlet weak var lockButton: UIButton!
    
    public var sureCallBack:((IOCHubCfgModel)->Void)?
    
    override func awakeFromNib() {
        super.awakeFromNib()
    }
    
    override init(frame: CGRect) {
        super.init(frame: frame)
    }
    
    required init?(coder: NSCoder) {
        super.init(coder: coder)
    }
    
    public func addDefaultParams(_ model:IOCHubCfgModel) {
        self.receiveBufferSizeTextFiled.text = "\(model.recvBufferSize)"
        self.sendBufferSizeTextField.text = "\(model.sendBufferSize)"
        self.socketTimeOutTextField.text = "\(model.socketTimeout)"
        self.maxConnectTextField.text = "\(model.maxConnSize)"
        self.packageSizeTextField.text = "\(model.sendSizePerPackage)"
        self.windowSizeTextField.text = "\(model.socketWndSize)"
        self.windowTimeOutTextField.text = "\(model.socketWndTimeout)"
        self.compressButton.isSelected = model.supportCompress
        self.lockButton.isSelected = model.openDeviceLock
    }
    
    @IBAction func optionAction(_ sender: UIButton) {
        sender.isSelected = !sender.isSelected
    }
    
    @IBAction func backgroudAction(_ sender: Any) {
        self.removeFromSuperview()
    }
    
    @IBAction func sureAction(_ sender: Any) {
        let model = IOCHubCfgModel.init()
        model.recvBufferSize = UInt32(self.receiveBufferSizeTextFiled.text ?? "") ?? 0
        model.sendBufferSize = UInt32(self.sendBufferSizeTextField.text  ?? "") ?? 0
        model.socketTimeout = UInt32(self.socketTimeOutTextField.text  ?? "") ?? 0
        model.maxConnSize = UInt32(self.maxConnectTextField.text  ?? "") ?? 0
        model.sendSizePerPackage = UInt32(self.packageSizeTextField.text  ?? "") ?? 0
        model.socketWndSize = UInt32(self.windowSizeTextField.text  ?? "") ?? 0
        model.socketWndTimeout = UInt32(self.windowTimeOutTextField.text  ?? "") ?? 0
        model.supportCompress = self.compressButton.isSelected
        model.openDeviceLock = self.lockButton.isSelected
//        model.localNetwork = "192.168.1.1"
        self.sureCallBack?(model)
        self.removeFromSuperview()
    }
    
    func textFieldDidBeginEditing(_ textField: UITextField) {
        let tag = textField.tag
        self.centerLayoutConstraint.constant = -CGFloat(tag) * 25.0
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        self.centerLayoutConstraint.constant = 0
    }
    
}
